diff -Nur squid-2.5.STABLE5/acconfig.h squid-2.5.STABLE5-wccpv2-L2/acconfig.h
--- squid-2.5.STABLE5/acconfig.h	Mon Jul  1 09:55:11 2002
+++ squid-2.5.STABLE5-wccpv2-L2/acconfig.h	Thu Mar 25 12:56:10 2004
@@ -112,9 +112,14 @@
 #undef SQUID_SNMP
 
 /*
- * Define to enable WCCP
+ * Define to enable WCCPv1
  */
 #define USE_WCCP 1
+
+/*
+ * Define to enable WCCPv2
+ */
+#undef USE_WCCPv2
 
 /*
  * Squid frequently calls gettimeofday() for accurate timestamping.
diff -Nur squid-2.5.STABLE5/configure squid-2.5.STABLE5-wccpv2-L2/configure
--- squid-2.5.STABLE5/configure	Sun Feb 29 22:30:21 2004
+++ squid-2.5.STABLE5-wccpv2-L2/configure	Thu Mar 25 12:56:11 2004
@@ -70,7 +70,9 @@
 ac_help="$ac_help
   --enable-referer-log    Enable logging of Referer header"
 ac_help="$ac_help
-  --disable-wccp          Disable Web Cache Coordination Protocol"
+  --disable-wccp          Disable Web Cache Coordination V1 Protocol"
+ac_help="$ac_help
+  --enable-wccpv2         Enable Web Cache Coordination V2 Protocol" 
 ac_help="$ac_help
   --enable-kill-parent-hack
                           Kill parent on shutdown"
@@ -2133,7 +2135,7 @@
 if test "${enable_wccp+set}" = set; then
   enableval="$enable_wccp"
    if test "$enableval" = "no" ; then
-    echo "Web Cache Coordination Protocol disabled"
+    echo "Web Cache Coordination V1 Protocol disabled"
     cat >> confdefs.h <<\EOF
 #define USE_WCCP 0
 EOF
@@ -2161,6 +2163,35 @@
 
 fi
 
+if false; then
+  USE_WCCPv2_TRUE=
+  USE_WCCPv2_FALSE='#'
+else
+  USE_WCCPv2_TRUE='#'
+  USE_WCCPv2_FALSE=
+fi
+# Check whether --enable-wccpv2 or --disable-wccpv2 was given.
+if test "${enable_wccpv2+set}" = set; then
+  enableval="$enable_wccpv2"
+  if test "$enableval" = "yes"; then
+   echo "Web Cache Coordination V2 Protocol Enabled"
+   cat >> confdefs.h <<\EOF
+#define USE_WCCPv2 1
+EOF
+
+
+
+if true; then
+  USE_WCCPv2_TRUE=
+  USE_WCCPv2_FALSE='#'
+else
+  USE_WCCPv2_TRUE='#'
+  USE_WCCPv2_FALSE=
+fi
+  fi
+
+fi
+
 
 
 
@@ -8594,6 +8625,8 @@
 s%@ENABLE_PINGER_FALSE@%$ENABLE_PINGER_FALSE%g
 s%@USE_DELAY_POOLS_TRUE@%$USE_DELAY_POOLS_TRUE%g
 s%@USE_DELAY_POOLS_FALSE@%$USE_DELAY_POOLS_FALSE%g
+s%@USE_WCCPv2_TRUE@%$USE_WCCPv2_TRUE%g
+s%@USE_WCCPv2_FALSE@%$USE_WCCPv2_FALSE%g
 s%@USE_SNMP_TRUE@%$USE_SNMP_TRUE%g
 s%@USE_SNMP_FALSE@%$USE_SNMP_FALSE%g
 s%@SNMPLIB@%$SNMPLIB%g
diff -Nur squid-2.5.STABLE5/configure.in squid-2.5.STABLE5-wccpv2-L2/configure.in
--- squid-2.5.STABLE5/configure.in	Sun Feb 29 22:30:21 2004
+++ squid-2.5.STABLE5-wccpv2-L2/configure.in	Thu Mar 25 12:56:11 2004
@@ -459,15 +459,26 @@
   fi
 ])
 
-AC_ARG_ENABLE(wccp,  
-[  --disable-wccp          Disable Web Cache Coordination Protocol],
+AC_ARG_ENABLE(wccp,
+[  --disable-wccp          Disable Web Cache Coordination V1 Protocol],
 [ if test "$enableval" = "no" ; then
-    echo "Web Cache Coordination Protocol disabled"
+    echo "Web Cache Coordination V1 Protocol disabled"
     AC_DEFINE(USE_WCCP, 0)
   else
     AC_DEFINE(USE_WCCP, 1)
   fi
-])      
+])
+
+AM_CONDITIONAL(USE_WCCPv2, false)
+AC_ARG_ENABLE(wccpv2,
+[  --enable-wccpv2          Enable Web Cache Coordination V2 Protocol],
+[ if test "$enableval" = "yes" ; then
+    echo "Web Cache Coordination V2 Protocol enabled"
+    AC_DEFINE(USE_WCCPv2, 1)
+    AM_CONDITIONAL(USE_WCCPv2, true)
+  fi
+])
+
 
 AC_ARG_ENABLE(kill-parent-hack,
 [  --enable-kill-parent-hack
diff -Nur squid-2.5.STABLE5/include/autoconf.h.in squid-2.5.STABLE5-wccpv2-L2/include/autoconf.h.in
--- squid-2.5.STABLE5/include/autoconf.h.in	Sat Jan 18 01:46:33 2003
+++ squid-2.5.STABLE5-wccpv2-L2/include/autoconf.h.in	Thu Mar 25 12:56:32 2004
@@ -149,9 +149,14 @@
 #undef SQUID_SNMP
 
 /*
- * Define to enable WCCP
+ * Define to enable WCCP V1
  */
 #define USE_WCCP 1
+
+/*
+ * Define to enable WCCP V2
+ */
+#undef USE_WCCPv2
 
 /*
  * Define this to include code which lets you specify access control
diff -Nur squid-2.5.STABLE5/src/Makefile.am squid-2.5.STABLE5-wccpv2-L2/src/Makefile.am
--- squid-2.5.STABLE5/src/Makefile.am	Sun Nov 10 15:30:03 2002
+++ squid-2.5.STABLE5-wccpv2-L2/src/Makefile.am	Thu Mar 25 16:33:18 2004
@@ -26,6 +26,12 @@
 DELAY_POOL_SOURCE = 
 endif
 
+if USE_WCCPv2
+WCCPv2_SOURCE = wccpv2.c
+else
+WCCPv2_SOURCE = 
+endif
+
 if ENABLE_HTCP
 HTCPSOURCE = htcp.c
 endif
@@ -104,6 +110,7 @@
 	unlinkd.c \
 	ssl_support.c \
 	ssl_support.h \
+	wccpv2.c \
 	win32.c
 
 squid_SOURCES = \
@@ -204,6 +211,7 @@
 	useragent.c \
 	wais.c \
 	wccp.c \
+	$(WCCPv2_SOURCE) \
 	whois.c \
 	$(WIN32SOURCE)
 
diff -Nur squid-2.5.STABLE5/src/Makefile.in squid-2.5.STABLE5-wccpv2-L2/src/Makefile.in
--- squid-2.5.STABLE5/src/Makefile.in	Wed Feb 12 02:03:14 2003
+++ squid-2.5.STABLE5-wccpv2-L2/src/Makefile.in	Thu Mar 25 12:56:53 2004
@@ -131,6 +131,9 @@
 @USE_DELAY_POOLS_TRUE@DELAY_POOL_SOURCE = delay_pools.c
 @USE_DELAY_POOLS_FALSE@DELAY_POOL_SOURCE = 
 
+@USE_WCCPv2_TRUE@WCCPv2_SOURCE = wccpv2.c
+@USE_WCCPv2_FALSE@WCCPv2_SOURCE =
+
 @ENABLE_HTCP_TRUE@HTCPSOURCE = htcp.c
 
 @MAKE_LEAKFINDER_TRUE@LEAKFINDERSOURCE = leakfinder.c
@@ -196,6 +199,7 @@
 	unlinkd.c \
 	ssl_support.c \
 	ssl_support.h \
+	wccpv2.c \
 	win32.c
 
 
@@ -297,6 +301,7 @@
 	useragent.c \
 	wais.c \
 	wccp.c \
+        $(WCCPv2_SOURCE) \
 	whois.c \
 	$(WIN32SOURCE)
 
@@ -471,8 +476,10 @@
 @ENABLE_SSL_TRUE@am__objects_8 = ssl_support.$(OBJEXT)
 @ENABLE_UNLINKD_TRUE@am__objects_9 = unlinkd.$(OBJEXT)
 @ENABLE_UNLINKD_FALSE@am__objects_9 =
-@ENABLE_WIN32SPECIFIC_FALSE@am__objects_10 =
-@ENABLE_WIN32SPECIFIC_TRUE@am__objects_10 = win32.$(OBJEXT)
+@USE_WCCPv2_FALSE@am__objects_10 =
+@USE_WCCPv2_TRUE@am__objects_10 = wccpv2.$(OBJEXT)
+@ENABLE_WIN32SPECIFIC_FALSE@am__objects_11 =
+@ENABLE_WIN32SPECIFIC_TRUE@am__objects_11 = win32.$(OBJEXT)
 am_squid_OBJECTS = access_log.$(OBJEXT) acl.$(OBJEXT) asn.$(OBJEXT) \
 	authenticate.$(OBJEXT) cache_cf.$(OBJEXT) CacheDigest.$(OBJEXT) \
 	cache_manager.$(OBJEXT) carp.$(OBJEXT) cbdata.$(OBJEXT) \
@@ -505,7 +512,7 @@
 	store_swapmeta.$(OBJEXT) store_swapout.$(OBJEXT) \
 	tools.$(OBJEXT) $(am__objects_9) url.$(OBJEXT) urn.$(OBJEXT) \
 	useragent.$(OBJEXT) wais.$(OBJEXT) wccp.$(OBJEXT) \
-	whois.$(OBJEXT) $(am__objects_10)
+	$(am__objects_10) whois.$(OBJEXT) $(am__objects_11)
 nodist_squid_OBJECTS = repl_modules.$(OBJEXT) auth_modules.$(OBJEXT) \
 	store_modules.$(OBJEXT) globals.$(OBJEXT) \
 	string_arrays.$(OBJEXT)
@@ -580,7 +587,7 @@
 @AMDEP_TRUE@	$(DEPDIR)/unlinkd.Po $(DEPDIR)/url.Po \
 @AMDEP_TRUE@	$(DEPDIR)/urn.Po $(DEPDIR)/useragent.Po \
 @AMDEP_TRUE@	$(DEPDIR)/wais.Po $(DEPDIR)/wccp.Po \
-@AMDEP_TRUE@	$(DEPDIR)/whois.Po $(DEPDIR)/win32.Po
+@AMDEP_TRUE@	$(DEPDIR)/wccpv2.Po $(DEPDIR)/whois.Po $(DEPDIR)/win32.Po
 COMPILE = $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) \
 	$(CPPFLAGS) $(AM_CFLAGS) $(CFLAGS)
 CCLD = $(CC)
@@ -815,6 +822,7 @@
 @AMDEP_TRUE@@am__include@ @am__quote@$(DEPDIR)/useragent.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@$(DEPDIR)/wais.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@$(DEPDIR)/wccp.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@$(DEPDIR)/wccpv2.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@$(DEPDIR)/whois.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@$(DEPDIR)/win32.Po@am__quote@
 
diff -Nur squid-2.5.STABLE5/src/cf.data.pre squid-2.5.STABLE5-wccpv2-L2/src/cf.data.pre
--- squid-2.5.STABLE5/src/cf.data.pre	Tue Feb 10 21:01:21 2004
+++ squid-2.5.STABLE5-wccpv2-L2/src/cf.data.pre	Thu Mar 25 12:56:43 2004
@@ -3266,6 +3266,12 @@
 LOC: Config.Wccp.router
 DEFAULT: 0.0.0.0
 IFDEF: USE_WCCP
+DOC_NONE
+NAME: wccp2_router
+TYPE: address
+LOC: Config.Wccp2.router
+DEFAULT: 0.0.0.0
+IFDEF: USE_WCCPv2
 DOC_START
 	Use this option to define your WCCP ``home'' router for
 	Squid.   Setting the 'wccp_router' to 0.0.0.0 (the default)
@@ -3277,6 +3283,12 @@
 LOC: Config.Wccp.version
 DEFAULT: 4
 IFDEF: USE_WCCP
+DOC_NONE
+NAME: wccp2_version
+TYPE: int
+LOC: Config.Wccp2.version
+DEFAULT: 4
+IFDEF: USE_WCCPv2
 DOC_START
 	According to some users, Cisco IOS 11.2 only supports WCCP
 	version 3.  If you're using that version of IOS, change
@@ -3294,6 +3306,18 @@
 LOC: Config.Wccp.outgoing
 DEFAULT: 255.255.255.255
 IFDEF: USE_WCCP
+DOC_NONE
+NAME: wccp2_incoming_address
+TYPE: address
+LOC: Config.Wccp2.incoming
+DEFAULT: 0.0.0.0
+IFDEF: USE_WCCPv2
+DOC_NONE
+NAME: wccp2_outgoing_address
+TYPE: address
+LOC: Config.Wccp2.outgoing
+DEFAULT: 255.255.255.255
+IFDEF: USE_WCCPv2
 DOC_START
         wccp_incoming_address   Use this option if you require WCCP
 				messages to be received on only one
diff -Nur squid-2.5.STABLE5/src/cf_gen_defines squid-2.5.STABLE5-wccpv2-L2/src/cf_gen_defines
--- squid-2.5.STABLE5/src/cf_gen_defines	Mon Dec  3 08:01:53 2001
+++ squid-2.5.STABLE5-wccpv2-L2/src/cf_gen_defines	Thu Mar 25 12:56:44 2004
@@ -18,6 +18,7 @@
 	define["USE_UNLINKD"]="--enable-unlinkd"
 	define["USE_USERAGENT_LOG"]="--enable-useragent-log"
 	define["USE_WCCP"]="--enable-wccp"
+	define["USE_WCCPv2"]="--enable-wccpv2"
 }
 /^IFDEF:/ {
 	if (define[$2] != "")
diff -Nur squid-2.5.STABLE5/src/main.c squid-2.5.STABLE5-wccpv2-L2/src/main.c
--- squid-2.5.STABLE5/src/main.c	Wed Dec 17 21:10:30 2003
+++ squid-2.5.STABLE5-wccpv2-L2/src/main.c	Tue Dec 14 14:55:04 2004
@@ -294,9 +294,6 @@
 #ifdef SQUID_SNMP
     snmpConnectionOpen();
 #endif
-#if USE_WCCP
-    wccpConnectionOpen();
-#endif
     clientdbInit();
     icmpOpen();
     netdbInit();
@@ -305,12 +302,26 @@
 #if USE_CARP
     carpInit();
 #endif
+#if USE_WCCP
+    wccpConnectionOpen();
+#endif
+#if USE_WCCPv2
+    /* We should only announce the cache using WCCP when we are ready */
+    wccp2ConnectionOpen();
+#endif
 }
 
 void
 serverConnectionsClose(void)
 {
     assert(shutting_down || reconfiguring);
+#if USE_WCCP
+    wccpConnectionShutdown();
+#endif
+#if USE_WCCPv2
+    /* Stop WCCP adverts before ceasing to handle HTTP requests */
+    wccp2ConnectionShutdown();
+#endif
     clientHttpConnectionsClose();
     icpConnectionShutdown();
 #if USE_HTCP
@@ -320,9 +331,6 @@
 #ifdef SQUID_SNMP
     snmpConnectionShutdown();
 #endif
-#if USE_WCCP
-    wccpConnectionShutdown();
-#endif
     asnFreeMemory();
 }
 
@@ -343,6 +351,9 @@
 #if USE_WCCP
     wccpConnectionClose();
 #endif
+#if USE_WCCPv2
+    wccp2ConnectionClose();
+#endif
 #if USE_DNSSERVERS
     dnsShutdown();
 #else
@@ -381,6 +392,9 @@
 #if USE_WCCP
     wccpInit();
 #endif
+#if USE_WCCPv2
+    wccp2Init();
+#endif
     serverConnectionsOpen();
     if (theOutIcpConnection >= 0) {
 	if (!Config2.Accel.on || Config.onoff.accel_with_proxy)
@@ -544,6 +558,9 @@
 #if USE_WCCP
     wccpInit();
 #endif
+#if USE_WCCPv2
+    wccp2Init();
+#endif
     serverConnectionsOpen();
     if (theOutIcpConnection >= 0) {
 	if (!Config2.Accel.on || Config.onoff.accel_with_proxy)
@@ -957,6 +974,13 @@
 SquidShutdown(void *unused)
 {
     debug(1, 1) ("Shutting down...\n");
+#if USE_WCCP
+    wccpConnectionClose();
+#endif
+#if USE_WCCPv2
+    /* Stop WCCP adverts before shutting anything else down */
+    wccp2ConnectionClose();
+#endif
 #if USE_DNSSERVERS
     dnsShutdown();
 #else
@@ -970,9 +994,6 @@
 #endif
 #ifdef SQUID_SNMP
     snmpConnectionClose();
-#endif
-#if USE_WCCP
-    wccpConnectionClose();
 #endif
     releaseServerSockets();
     commCloseAllSockets();
diff -Nur squid-2.5.STABLE5/src/protos.h squid-2.5.STABLE5-wccpv2-L2/src/protos.h
--- squid-2.5.STABLE5/src/protos.h	Wed Feb  4 17:42:28 2004
+++ squid-2.5.STABLE5-wccpv2-L2/src/protos.h	Thu Mar 25 12:56:55 2004
@@ -571,6 +571,13 @@
 extern void wccpConnectionClose(void);
 #endif /* USE_WCCP */
 
+#if USE_WCCPv2
+extern void wccp2Init(void);
+extern void wccp2ConnectionOpen(void);
+extern void wccp2ConnectionShutdown(void);
+extern void wccp2ConnectionClose(void);
+#endif /* USE_WCCPv2 */
+
 extern void icpHandleIcpV3(int, struct sockaddr_in, char *, int);
 extern int icpCheckUdpHit(StoreEntry *, request_t * request);
 extern void icpConnectionsOpen(void);
diff -Nur squid-2.5.STABLE5/src/structs.h squid-2.5.STABLE5-wccpv2-L2/src/structs.h
--- squid-2.5.STABLE5/src/structs.h	Wed Feb  4 17:42:28 2004
+++ squid-2.5.STABLE5-wccpv2-L2/src/structs.h	Thu Mar 25 12:57:00 2004
@@ -451,6 +451,14 @@
 	int version;
     } Wccp;
 #endif
+#if USE_WCCPv2
+    struct {
+        struct in_addr router;
+        struct in_addr incoming;
+        struct in_addr outgoing;
+        int version;
+    } Wccp2;
+#endif
     char *as_whois_server;
     struct {
 	char *log;
diff -Nur squid-2.5.STABLE5/src/wccpv2.c squid-2.5.STABLE5-wccpv2-L2/src/wccpv2.c
--- squid-2.5.STABLE5/src/wccpv2.c	Thu Jan  1 01:00:00 1970
+++ squid-2.5.STABLE5-wccpv2-L2/src/wccpv2.c	Thu Mar 25 12:57:02 2004
@@ -0,0 +1,621 @@
+/*
+ * $Id$
+ *
+ * DEBUG: section 80     WCCP Support
+ * AUTHOR: Glenn Chisholm
+ *
+ * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from the
+ *  Internet community.  Development is led by Duane Wessels of the
+ *  National Laboratory for Applied Network Research and funded by the
+ *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
+ *  Duane Wessels and the University of California San Diego.  Please
+ *  see the COPYRIGHT file for full details.  Squid incorporates
+ *  software developed and/or copyrighted by other sources.  Please see
+ *  the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+#include "squid.h"
+#include <netdb.h>
+
+#if USE_WCCPv2
+
+#define WCCP_PORT 2048
+#define WCCP_VERSION 4
+#define WCCP_REVISION 0
+#define WCCP_RESPONSE_SIZE 12448
+#define WCCP_ACTIVE_CACHES 32
+#define WCCP_HASH_SIZE 32
+#define WCCP_BUCKETS 256
+#define WCCP_CACHE_LEN 4
+
+#define WCCP_HERE_I_AM 7
+#define WCCP_I_SEE_YOU 8
+#define WCCP_ASSIGN_BUCKET 9
+
+static int theInWccpConnection = -1;
+static int theOutWccpConnection = -1;
+static int change;
+static int number_caches = 0;
+static int new_number_caches = 0;
+static struct in_addr local_ip;
+
+static PF wccp2HandleUdp;
+static int wccp2LowestIP(void);
+static EVH wccp2HereIam;
+static EVH wccp2AssignBuckets;
+
+/* KDW WCCP V2 */
+#define WCCP2_HERE_I_AM		10
+#define WCCP2_I_SEE_YOU		11
+#define WCCP2_REDIRECT_ASSIGN		12
+#define WCCP2_REMOVAL_QUERY		13
+#define WCCP2_VERSION			0x200
+
+#define WCCP2_SECURITY_INFO		0
+#define WCCP2_NO_SECURITY		0
+#define WCCP2_MD5_SECURITY		1	/* Not Supported Yet */
+
+#define WCCP2_SERVICE_INFO		1
+#define WCCP2_SERVICE_STANDARD		0
+#define WCCP2_SERVICE_DYNAMIC		1	/* Not Supported Yet */
+#define WCCP2_SERVICE_ID_HTTP		0x00
+
+#define WCCP2_ROUTER_ID_INFO		2
+
+#define WCCP2_WC_ID_INFO		3
+
+#define WCCP2_RTR_VIEW_INFO		4
+
+#define WCCP2_WC_VIEW_INFO		5
+
+#define WCCP2_REDIRECT_ASSIGNMENT	6
+
+#define WCCP2_QUERY_INFO		7
+
+#define WCCP2_CAPABILITY_INFO		8
+#define WCCP2_FORWARDING_METHOD		0x01
+#define WCCP2_ASSIGNMENT_METHOD		0x02
+#define WCCP2_PACKET_RETURN_METHOD	0x03
+#define WCCP2_FORWARDING_METHOD_GRE     0x00000001
+#define WCCP2_FORWARDING_METHOD_L2      0x00000002
+#define WCCP2_PACKET_RETURN_METHOD_GRE  0x00000001
+#define WCCP2_PACKET_RETURN_METHOD_L2   0x00000002
+#define WCCP2_ASSIGNMENT_METHOD_HASH    0x00000001
+#define WCCP2_ASSIGNMENT_METHOD_MASK    0x00000002
+
+struct wccp2_here_i_am_t {
+	uint32_t type;
+	uint16_t version;
+	uint16_t length;
+  	uint16_t security_type;
+	uint16_t security_length;
+	uint32_t security_option;
+	uint16_t service_type;
+	uint16_t service_length;
+	uint8_t service;
+	uint8_t serviceid;
+	char service_filler[22];
+	uint16_t cache_identity_type;
+	uint16_t cache_identity_length;
+	struct in_addr cache_identity_addr;
+	char cache_identity_filler[40];
+	uint16_t cache_view_type;
+	uint16_t cache_view_length;
+	uint32_t cache_view_version;
+	uint32_t cache_view_num_routers;
+	struct in_addr cache_view_rtr1_addr;
+	uint32_t cache_view_rtr1_receive_id;
+	uint32_t cache_view_num_caches;
+	int id;
+	uint16_t capability_info_type;
+	uint16_t capability_info_length;
+	uint16_t capability_forwarding_method_type;
+	uint16_t capability_forwarding_method_length;
+	uint32_t capability_forwarding_method_value;
+	uint16_t capability_packet_return_method_type;
+	uint16_t capability_packet_return_method_length;
+	uint32_t capability_packet_return_method_value;
+	uint16_t capability_assignment_method_type;
+	uint16_t capability_assignment_method_length;
+	uint32_t capability_assignment_method_value;
+};
+
+static struct wccp2_here_i_am_t wccp2_here_i_am;
+
+struct wccp2_i_see_you_t {
+	uint32_t type;
+	uint16_t version;
+	uint16_t length;
+	char data[WCCP_RESPONSE_SIZE];
+	int id;
+};
+
+static struct wccp2_i_see_you_t wccp2_i_see_you;
+
+struct wccp2_item_header_t {
+	uint16_t type;
+	uint16_t length;
+};
+
+static struct wccp2_item_header_t wccp2_item_header;
+
+struct wccp2_router_id_element_t {
+	uint16_t type;
+	uint16_t length;
+	struct in_addr router_addr;
+	uint32_t received_id;
+};
+
+static struct wccp2_router_id_element_t wccp2_router_id_element;
+
+struct wccp2_router_info_t {
+	uint16_t type;
+	uint16_t length;
+	uint32_t member_change;
+	struct in_addr assignment_key;
+	uint32_t assignment_key_change;
+	uint32_t num_routers;
+	struct in_addr router1_addr;
+	uint32_t num_caches;
+};
+
+static struct wccp2_router_info_t wccp2_router_info;
+
+struct wccp2_wc_id_element_t {
+	struct in_addr cache_addr;
+	char data[40];
+};
+
+static struct wccp2_wc_id_element_t wccp2_wc_id_element[WCCP_ACTIVE_CACHES];
+
+struct wccp2_redirect_assign_t {
+	uint32_t type;
+	uint16_t version;
+	uint16_t length;
+  	uint16_t security_type;
+	uint16_t security_length;
+	uint32_t security_option;
+	uint16_t service_type;
+	uint16_t service_length;
+	uint8_t service;
+	uint8_t serviceid;
+	char service_filler[22];
+	uint16_t assignment_type;
+	uint16_t assignment_length;
+	struct in_addr assignment_key;
+	uint32_t assignment_key_change;
+	uint32_t assignment_num_routers;
+	struct in_addr assignment_router1_addr;
+	uint32_t assignment_router1_receive_id;
+	uint32_t assignment_router1_change_number;
+	uint32_t assignment_num_caches;
+/*	struct in_addr assignment_cache1_addr;		*/
+/*	char buckets[WCCP_BUCKETS];			*/
+};
+
+struct wccp2_assign_bucket_t {
+    int type;
+    int id;
+    int number;
+};
+
+static uint32_t wccp2_received_id;
+static struct in_addr wccp2_router_addr;
+
+
+/* END WCCP V2 */
+
+/*
+ * The functions used during startup:
+ * wccp2Init
+ * wccp2ConnectionOpen
+ * wccp2ConnectionShutdown
+ * wccp2ConnectionClose
+ */
+
+void
+wccp2Init(void)
+{
+    debug(80, 5) ("wccp2Init: Called\n");
+    if (eventFind(wccp2HereIam, NULL))
+	return;
+    change = 1;
+    wccp2_here_i_am.type = htonl(WCCP2_HERE_I_AM);
+    wccp2_here_i_am.version = htons(WCCP2_VERSION);
+    wccp2_here_i_am.length = htons(sizeof(wccp2_here_i_am)-8);
+    wccp2_here_i_am.security_type = htons(WCCP2_SECURITY_INFO);
+    wccp2_here_i_am.security_length = htons(sizeof(wccp2_here_i_am.security_option));
+    wccp2_here_i_am.security_option = htonl(WCCP2_NO_SECURITY);
+    wccp2_here_i_am.service_type = htons(WCCP2_SERVICE_INFO);
+    wccp2_here_i_am.service_length =
+	    htons(sizeof(wccp2_here_i_am.service) +
+	    sizeof(wccp2_here_i_am.serviceid) +
+	    sizeof(wccp2_here_i_am.service_filler));
+    wccp2_here_i_am.service = WCCP2_SERVICE_STANDARD;
+    wccp2_here_i_am.serviceid = WCCP2_SERVICE_ID_HTTP;
+    memset(&wccp2_here_i_am.service_filler, '\0', sizeof(wccp2_here_i_am.service_filler));
+    wccp2_here_i_am.cache_identity_type = htons(WCCP2_WC_ID_INFO);
+    wccp2_here_i_am.cache_identity_length = 
+	    htons(sizeof(wccp2_here_i_am.cache_identity_addr) +
+	    sizeof(wccp2_here_i_am.cache_identity_filler));
+    memset(&wccp2_here_i_am.cache_identity_filler, '\0', sizeof(wccp2_here_i_am.cache_identity_filler));
+    wccp2_here_i_am.capability_info_type = htons(WCCP2_CAPABILITY_INFO);
+    wccp2_here_i_am.capability_info_length = htons(
+	    sizeof(wccp2_here_i_am.capability_forwarding_method_type) +
+	    sizeof(wccp2_here_i_am.capability_forwarding_method_length) +
+	    sizeof(wccp2_here_i_am.capability_forwarding_method_value) +
+	    sizeof(wccp2_here_i_am.capability_packet_return_method_type) +
+	    sizeof(wccp2_here_i_am.capability_packet_return_method_length) +
+	    sizeof(wccp2_here_i_am.capability_packet_return_method_value) +
+	    sizeof(wccp2_here_i_am.capability_assignment_method_type) +
+	    sizeof(wccp2_here_i_am.capability_assignment_method_length) +
+	    sizeof(wccp2_here_i_am.capability_assignment_method_value));
+    wccp2_here_i_am.capability_forwarding_method_type = 
+	    htons(WCCP2_FORWARDING_METHOD);
+    wccp2_here_i_am.capability_forwarding_method_length = 
+	    htons(sizeof(wccp2_here_i_am.capability_forwarding_method_value));
+    wccp2_here_i_am.capability_forwarding_method_value = 
+	    htonl(WCCP2_FORWARDING_METHOD_L2);
+    wccp2_here_i_am.capability_packet_return_method_type = 
+	    htons(WCCP2_PACKET_RETURN_METHOD);
+    wccp2_here_i_am.capability_packet_return_method_length = 
+	    htons(sizeof(wccp2_here_i_am.capability_packet_return_method_value));
+    wccp2_here_i_am.capability_packet_return_method_value = 
+	    htonl(WCCP2_PACKET_RETURN_METHOD_GRE);
+    wccp2_here_i_am.capability_assignment_method_type =
+	    htons(WCCP2_ASSIGNMENT_METHOD);
+    wccp2_here_i_am.capability_assignment_method_length = 
+	    htons(sizeof(wccp2_here_i_am.capability_assignment_method_value));
+    wccp2_here_i_am.capability_assignment_method_value = 
+	    htonl(WCCP2_ASSIGNMENT_METHOD_HASH);
+    wccp2_here_i_am.cache_view_type = htons(WCCP2_WC_VIEW_INFO);
+    wccp2_here_i_am.cache_view_length = 
+	    htons(sizeof(wccp2_here_i_am.cache_view_version) +
+	    sizeof(wccp2_here_i_am.cache_view_num_routers) +
+	    sizeof(wccp2_here_i_am.cache_view_num_caches) +
+	    sizeof(wccp2_here_i_am. cache_view_rtr1_addr) +
+	    sizeof(wccp2_here_i_am.cache_view_rtr1_receive_id));
+    wccp2_here_i_am.cache_view_version = htonl(1);
+    wccp2_here_i_am.cache_view_num_routers = htonl(1);
+    wccp2_here_i_am.cache_view_rtr1_addr = Config.Wccp2.router;
+    wccp2_here_i_am.cache_view_rtr1_receive_id =
+	    wccp2_router_id_element.received_id;
+    wccp2_here_i_am.cache_view_num_caches = htonl(0);
+
+    if (Config.Wccp2.router.s_addr != any_addr.s_addr)
+	if (!eventFind(wccp2HereIam, NULL))
+	    eventAdd("wccp2HereIam", wccp2HereIam, NULL, 10.0, 1);
+}
+
+void
+wccp2ConnectionOpen(void)
+{
+    u_short port = WCCP_PORT;
+    struct sockaddr_in router, local;
+    int local_len, router_len;
+    debug(80, 5) ("wccp2ConnectionOpen: Called\n");
+    if (Config.Wccp2.router.s_addr == any_addr.s_addr) {
+	debug(1, 1) ("WCCP Disabled.\n");
+	return;
+    }
+    theInWccpConnection = comm_open(SOCK_DGRAM,
+	0,
+	Config.Wccp2.incoming,
+	port,
+	COMM_NONBLOCKING,
+	"WCCP Socket");
+    if (theInWccpConnection < 0)
+	fatal("Cannot open WCCP Port");
+    commSetSelect(theInWccpConnection,
+	COMM_SELECT_READ,
+	wccp2HandleUdp,
+	NULL,
+	0);
+    debug(1, 1) ("Accepting WCCP v2 messages on port %d, FD %d.\n",
+	(int) port, theInWccpConnection);
+    if (Config.Wccp2.outgoing.s_addr != no_addr.s_addr) {
+	theOutWccpConnection = comm_open(SOCK_DGRAM,
+	    0,
+	    Config.Wccp2.outgoing,
+	    port,
+	    COMM_NONBLOCKING,
+	    "WCCP Socket");
+	if (theOutWccpConnection < 0)
+	    fatal("Cannot open Outgoing WCCP Port");
+	commSetSelect(theOutWccpConnection,
+	    COMM_SELECT_READ,
+    wccp2HandleUdp,
+	    NULL, 0);
+	debug(1, 1) ("Outgoing WCCP v2 messages on port %d, FD %d.\n",
+	    (int) port, theOutWccpConnection);
+	fd_note(theOutWccpConnection, "Outgoing WCCP socket");
+	fd_note(theInWccpConnection, "Incoming WCCP socket");
+    } else {
+	theOutWccpConnection = theInWccpConnection;
+    }
+    router_len = sizeof(router);
+    memset(&router, '\0', router_len);
+    router.sin_family = AF_INET;
+    router.sin_port = htons(port);
+    router.sin_addr = Config.Wccp2.router;
+    if (connect(theOutWccpConnection, (struct sockaddr *) &router, router_len))
+	fatal("Unable to connect WCCP out socket");
+    local_len = sizeof(local);
+    memset(&local, '\0', local_len);
+    if (getsockname(theOutWccpConnection, (struct sockaddr *) &local, &local_len))
+	fatal("Unable to getsockname on WCCP out socket");
+    local_ip.s_addr = local.sin_addr.s_addr;
+}
+
+void
+wccp2ConnectionShutdown(void)
+{
+    if (theInWccpConnection < 0)
+	return;
+    if (theInWccpConnection != theOutWccpConnection) {
+	debug(80, 1) ("FD %d Closing WCCP socket\n", theInWccpConnection);
+	comm_close(theInWccpConnection);
+    }
+    assert(theOutWccpConnection > -1);
+    commSetSelect(theOutWccpConnection, COMM_SELECT_READ, NULL, NULL, 0);
+}
+
+void
+wccp2ConnectionClose(void)
+{
+    wccp2ConnectionShutdown();
+    if (theOutWccpConnection > -1) {
+	debug(80, 1) ("FD %d Closing WCCP socket\n", theOutWccpConnection);
+	comm_close(theOutWccpConnection);
+    }
+}
+
+/*
+ * Functions for handling the requests.
+ */
+
+/*
+ * Accept the UDP packet
+ */
+static void
+wccp2HandleUdp(int sock, void *not_used)
+{
+    struct sockaddr_in from;
+    socklen_t from_len;
+    int len, offset;
+
+    debug(80, 6) ("wccp2HandleUdp: Called.\n");
+
+    commSetSelect(sock, COMM_SELECT_READ, wccp2HandleUdp, NULL, 0);
+    from_len = sizeof(struct sockaddr_in);
+    memset(&from, '\0', from_len);
+    memset(&wccp2_i_see_you, '\0', sizeof(wccp2_i_see_you));
+
+    statCounter.syscalls.sock.recvfroms++;
+
+    len = recvfrom(sock,
+	    &wccp2_i_see_you,
+	    WCCP_RESPONSE_SIZE,
+	    0,
+	    (struct sockaddr *) &from,
+	    &from_len);
+
+    if (len < 0)
+	return;
+    if (Config.Wccp2.router.s_addr != from.sin_addr.s_addr)
+	return;
+    if (ntohs(wccp2_i_see_you.version) != WCCP2_VERSION)
+	return;
+    if (ntohl(wccp2_i_see_you.type) != WCCP2_I_SEE_YOU)
+	return;
+
+    debug(80, 1) ("Incoming WCCP v2 I_SEE_YOU length %d.\n",
+	     ntohs(wccp2_i_see_you.length));
+    memcpy(&wccp2_item_header, &wccp2_i_see_you.data[0], sizeof(wccp2_item_header));
+    if (ntohs(wccp2_item_header.type) != WCCP2_SECURITY_INFO) {
+	debug(80,1) ("WCCP2_I_SEE_YOU missing WCCP2_SECURITY_INFO\n");
+	return;
+    }
+
+    offset = ntohs(wccp2_item_header.length) + 4;
+    memcpy(&wccp2_item_header, &wccp2_i_see_you.data[offset], sizeof(wccp2_item_header));
+    if (ntohs(wccp2_item_header.type) != WCCP2_SERVICE_INFO) {
+	debug(80,1) ("WCCP2_I_SEE_YOU missing WCCP2_SERVICE_INFO offset %d\n", offset);
+	return;
+    }
+    offset += ntohs(wccp2_item_header.length) + 4; /* Skip WCCP2_SERVICE_INFO */
+    memcpy(&wccp2_item_header, &wccp2_i_see_you.data[offset], sizeof(wccp2_item_header));
+    if (ntohs(wccp2_item_header.type) != WCCP2_ROUTER_ID_INFO) {
+	debug(80,1) ("WCCP2_I_SEE_YOU missing WCCP2_ROUTER_ID_INFO\n");
+	return;
+    }
+    memcpy(&wccp2_router_id_element, &wccp2_i_see_you.data[offset], sizeof(wccp2_router_id_element));
+    debug(80, 1) ("Incoming WCCP2_I_SEE_YOU received id = %d.\n", ntohl(wccp2_router_id_element.received_id));
+
+    wccp2_router_addr = wccp2_router_id_element.router_addr;
+    wccp2_received_id = wccp2_router_id_element.received_id;
+
+    offset += ntohs(wccp2_router_id_element.length) + 4;
+    memcpy(&wccp2_router_info, &wccp2_i_see_you.data[offset], sizeof(wccp2_router_info));
+
+    debug(80, 1) ("Incoming WCCP2_I_SEE_YOU member change = %d tmp=%d.\n", change,ntohl(wccp2_router_info.member_change));
+
+    if (ntohs(wccp2_router_info.type) != WCCP2_RTR_VIEW_INFO) {
+        debug(80,1) ("WCCP2_I_SEE_YOU missing WCCP2_RTR_VIEW_INFO\n");
+	return;
+    }
+    if (ntohl(wccp2_router_info.num_routers) != 1) {
+    	debug(80,1) ("WCCP2_I_SEE_YOU expect one router in WCCP2_RTR_VIEW_INFO\n");
+	return;
+    }
+
+    new_number_caches = ntohl(wccp2_router_info.num_caches);
+    if (new_number_caches > WCCP_ACTIVE_CACHES) {
+        new_number_caches = WCCP_ACTIVE_CACHES;
+    }
+    debug(80, 1) ("Incoming WCCP2_I_SEE_YOU existing num_caches = %d, new num_caches = %d\n", number_caches, new_number_caches);
+    offset += sizeof(wccp2_router_info);
+    memset(&wccp2_wc_id_element, '\0', sizeof(wccp2_wc_id_element));
+    memcpy(&wccp2_wc_id_element, &wccp2_i_see_you.data[offset], 
+            (sizeof(struct wccp2_wc_id_element_t) * new_number_caches));
+
+    if ((!change) && (number_caches == new_number_caches)) {
+	change = ntohl(wccp2_router_info.member_change);
+	debug(80, 1) ("Incoming WCCP2_I_SEE_YOU member change = %d.\n", change);
+	return;
+    }
+    if (change != ntohl(wccp2_router_info.member_change)) {
+	change = ntohl(wccp2_router_info.member_change);
+	debug(80, 1) ("Incoming WCCP2_I_SEE_YOU membership has changed: considering assign buckets\n");
+	if (wccp2LowestIP()) {
+	    debug(80, 1) ("Incoming WCCP2_I_SEE_YOU we are lowest IP in cache membership\n");
+	    if (!eventFind(wccp2AssignBuckets, NULL)) {
+		eventAdd("wccp2AssignBuckets", wccp2AssignBuckets, NULL, 25.0, 1);
+	    }
+	}
+    }
+}
+
+static int
+wccp2LowestIP(void)
+{
+    int loop;
+    for (loop = 0; loop < new_number_caches; loop++) {
+	if (wccp2_wc_id_element[loop].cache_addr.s_addr < local_ip.s_addr) {
+	    return 0;
+	}
+    }
+    return 1;
+}
+
+static void
+wccp2HereIam(void *voidnotused)
+{
+    debug(80, 6) ("wccp2HereIam: Called\n");
+
+    wccp2_here_i_am.cache_identity_addr = local_ip;
+    wccp2_here_i_am.id = wccp2_i_see_you.id;
+    wccp2_here_i_am.cache_view_rtr1_receive_id = wccp2_received_id;
+    wccp2_here_i_am.cache_view_rtr1_addr = wccp2_router_addr;
+    send(theOutWccpConnection,
+	    &wccp2_here_i_am,
+	    sizeof(wccp2_here_i_am),
+	    0);
+
+    if (!eventFind(wccp2HereIam, NULL)) {
+	eventAdd("wccp2HereIam", wccp2HereIam, NULL, 10.0, 1);
+    }
+}
+
+static void
+wccp2AssignBuckets(void *voidnotused)
+{
+    struct wccp2_redirect_assign_t *wccp2_redirect_assign;
+    int wra_len;
+    char *buckets;
+    int buckets_per_cache;
+    int loop;
+    int bucket = 0;
+    int *caches;
+    int cache_len;
+    char *buf;
+
+    debug(80, 6) ("wccp2AssignBuckets: Called\n");
+    number_caches = ntohl(wccp2_router_info.num_caches);
+    if (number_caches > WCCP_ACTIVE_CACHES) {
+        number_caches = WCCP_ACTIVE_CACHES;
+    }
+    assert(number_caches > 0);
+    wra_len = sizeof(struct wccp2_redirect_assign_t);
+    cache_len = WCCP_CACHE_LEN * number_caches;
+
+    buf = xmalloc(wra_len + WCCP_BUCKETS + cache_len);
+    wccp2_redirect_assign = (struct wccp2_redirect_assign_t *) buf;
+    caches = (int *) (buf + wra_len);
+    buckets = buf + wra_len + cache_len;
+
+    memset(wccp2_redirect_assign, '\0',
+    	    sizeof(struct wccp2_redirect_assign_t));
+    memset(buckets, 0xFF, WCCP_BUCKETS);
+
+    buckets_per_cache = WCCP_BUCKETS / number_caches;
+    debug(80, 1) ("WCCP2 Redirect Assignment: %d buckets per cache\n", buckets_per_cache);
+    for (loop = 0; loop < number_caches; loop++) {
+        int i;
+	debug(80, 6) ("WCCP2: cache %d is %s\n", loop,
+		inet_ntoa(wccp2_wc_id_element[loop].cache_addr));
+	xmemcpy(&caches[loop],
+		&wccp2_wc_id_element[loop].cache_addr.s_addr,
+		sizeof(*caches));
+	for (i = 0; i < buckets_per_cache; i++) {
+	    assert(bucket < WCCP_BUCKETS);
+	    buckets[bucket++] = loop;
+	}
+    }
+    while (bucket < WCCP_BUCKETS) {
+        buckets[bucket++] = number_caches - 1;
+    }
+    wccp2_redirect_assign->type = htonl(WCCP2_REDIRECT_ASSIGN);
+    wccp2_redirect_assign->version = htons(WCCP2_VERSION);
+    wccp2_redirect_assign->length = htons(wra_len+cache_len+WCCP_BUCKETS-8);
+    wccp2_redirect_assign->security_type = htons(WCCP2_SECURITY_INFO);
+    wccp2_redirect_assign->security_length =
+            htons(sizeof(wccp2_redirect_assign->security_option));
+    wccp2_redirect_assign->security_option = htonl(WCCP2_NO_SECURITY);
+    wccp2_redirect_assign->service_type = htons(WCCP2_SERVICE_INFO);
+    wccp2_redirect_assign->service_length =
+            htons(sizeof(wccp2_redirect_assign->service) +
+            sizeof(wccp2_redirect_assign->serviceid) +
+            sizeof(wccp2_redirect_assign->service_filler));
+    wccp2_redirect_assign->service = WCCP2_SERVICE_STANDARD;
+    wccp2_redirect_assign->serviceid = WCCP2_SERVICE_ID_HTTP;
+/*    memset(wccp2_redirect_assign->service_filler, '\0',
+    	sizeof(wccp2_redirect_assign->service_filler)); *** ALREADY NULs */
+    wccp2_redirect_assign->assignment_type = htons(WCCP2_REDIRECT_ASSIGNMENT);
+    wccp2_redirect_assign->assignment_length =
+            htons(sizeof(wccp2_redirect_assign->assignment_key) +
+            sizeof(wccp2_redirect_assign->assignment_key_change) +
+            sizeof(wccp2_redirect_assign->assignment_num_routers) +
+            sizeof(wccp2_redirect_assign->assignment_router1_addr) +
+            sizeof(wccp2_redirect_assign->assignment_router1_receive_id) +
+            sizeof(wccp2_redirect_assign->assignment_router1_change_number) +
+            sizeof(wccp2_redirect_assign->assignment_num_caches) +
+            cache_len +
+            WCCP_BUCKETS);
+    wccp2_redirect_assign->assignment_key =
+    	    wccp2_here_i_am.cache_identity_addr;
+    wccp2_redirect_assign->assignment_key_change = htonl(change);
+    wccp2_redirect_assign->assignment_num_routers = htonl(1);
+    wccp2_redirect_assign->assignment_router1_addr = wccp2_router_addr;
+    wccp2_redirect_assign->assignment_router1_receive_id = wccp2_received_id;
+    wccp2_redirect_assign->assignment_router1_change_number = htonl(change);
+    wccp2_redirect_assign->assignment_num_caches = htonl(number_caches);
+
+    debug(80, 1) ("WCCP2 Assigning Redirect\n");
+    send(theOutWccpConnection,
+	buf,
+	wra_len + cache_len + WCCP_BUCKETS,
+	0);
+    change = 0;
+    xfree(buf);
+}
+
+#endif /* USE_WCCPv2 */
+
